// 그리디 문제
// 조금 생각하기 어려울 수 있다.
// 핵심은 그리디 문제는 대부분
// 정렬로 시작한다.
// 정렬을 통해서 어느정도 그리디적인 문제로 바뀌게 하고
// 그 다음 최소의 연산으로 결과값이 나오게 한다.
// 따라서 그리디는 먼저 정렬적으로 생각하고
// 그 다음에는 근처에 있는 값끼리 서로 비교하면서
// 최적의 결과를 뽑는다는 생각으로 푼다.
// 여기서는 자동차가 진입하여 나간 시점에 카메라를 설치한다는 생각을 한다.
// 따라서, 먼저 경계선 부근에 카메라를 설치하고
// 그 다음 오는 자동차에 대해서 경계선 부근과 비교하여
// 카메라를 더 설치할 지를 보도록 한다.
// 경계를 넘어서면 카메라가 더 필요한 경우가 되는 것이다.

function solution(routes) {
  routes = routes.sort((a, b) => a[1] - b[1]);

  let cnt = 1;
  let cam = routes[0][1];

  for (let i = 1; i < routes.length; ++i) {
    if (cam < routes[i][0]) {
      cam = routes[i][1];
      ++cnt;
    } else if (cam > routes[i][0] && cam > routes[i][1]) {
      cam = routes[i][1];
    }
  }

  return cnt;
}
